Imports Syncfusion.Windows.Forms.Grid
Public Class Form1

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    Me.grdCB_EPA.Model.CutPaste.ClipboardFlags += GridDragDropFlags.NoAppendRows + GridDragDropFlags.RowHeader + GridDragDropFlags.ColHeader + GridDragDropFlags.NoAppendCols - GridDragDropFlags.Styles
        '   Me.grdCB_EPA.AllowSelection -= GridSelectionFlags.Column
    Dim i As Integer

    For i = 1 To 98
      grdCB_EPA(0, i).CellValue = "Source" & " " & i
    Next
        grdCB_EPA(1, 2).CellValue = 601
        grdCB_EPA(2, 2).CellValue = 602

        AddHandler grdCB_EPA.Model.ClipboardPasted, AddressOf grdCB_EPA_ClipboardPasted

    End Sub

    Private Sub grdCB_EPA_ClipboardPasted(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs)
        If clipBoardHeaderContents.Length > 0 Then
            Clipboard.SetText(clipBoardHeaderContents)
            includesHeader = True
        End If
    End Sub
    Private includesHeader As Boolean = False
    Private Sub grdCB_EPA_ClipboardCopy(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs) Handles grdCB_EPA.ClipboardCopy
        includesHeader = grdCB_EPA.Selections.Ranges.AnyRangeIntersects(GridRangeInfo.Row(0))
    End Sub

    Private clipBoardHeaderContents As String = ""
    Private Sub grdCB_EPA_ClipboardPaste(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs) Handles grdCB_EPA.ClipboardPaste
        Console.WriteLine(Clipboard.GetDataObject().GetFormats().GetLength(0))
        If Clipboard.GetDataObject().GetFormats().GetLength(0) > 3 Then
            includesHeader = False ' copy was done in excel ...
        End If
        Dim targetRange As GridRangeInfo = grdCB_EPA.Selections.Ranges.ActiveRange
        If targetRange.IsCols And Not includesHeader Then
            'do not allow paste into header
            grdCB_EPA.Selections.Clear()
            targetRange = targetRange.ExpandRange(1, 1, grdCB_EPA.RowCount, grdCB_EPA.ColCount)
            grdCB_EPA.Selections.SelectRange(targetRange, True)
        ElseIf includesHeader And Not targetRange.IsCols Then
            'if you copied the header, remove it from the clipboard
            Dim text As String = Clipboard.GetText()
            Dim i As Integer = text.IndexOf(Environment.NewLine)
            If i > -1 Then
                'strip out the copied header row
                clipBoardHeaderContents = text
                Clipboard.SetText(text.Substring(i + 1).Trim())
            End If
            includesHeader = False
        End If

    End Sub

    Private Sub grdCB_EPA_PasteCellText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridPasteCellTextEventArgs) Handles grdCB_EPA.PasteCellText

        If CType(e.Style, Syncfusion.Windows.Forms.Grid.GridStyleInfo).ReadOnly Then
            e.Cancel = True
        End If
        If e.RowIndex = 0 Then
            e.Cancel = True
            Return
        End If
        Try
            If e.Text.Length > 0 Then
                Dim i As Single = Single.Parse(e.Text)
                Select Case i
                    Case 0, 601.0F To 699.0F
                    Case Else
                        Throw New Exception("")
                End Select
            End If
        Catch
            MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
              "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
              MessageBoxIcon.Warning)
            e.Abort = True
        End Try
    End Sub
End Class
